// Space Mission. Started: 05/05/2003

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public final class SpaceMission extends java.applet.Applet implements Runnable
{
	Thread updateThread;
	Math oMath;
	Graphics oGraphics;
	MediaTracker oTracker;
	ImageFilter oFilter;
	Image gBuffer, gEgos, gEgo[], gShips, gShip[], gBullets, gBullet[], gStars, 
	 gStar[], gNumbers, gNumber[], gExplodes, gExplode[], gCapsules, gCapsule[],
	 gBonuses, gBonus[], gEBullets, gEBullet[], gShields, gShield[], gStatusBar,
	 gEgoShield, gTitle;
	Color nBlack, nWhite, nMagenta;
	String cNumber;
	char cInput, aChars[];
	int nAppH = 300, nAppW = 300;
	int nTitleY = nAppH, i, j, k, nTest, nCheatCount;
	boolean lLeft, lRight, lShoot, lBombing, lTitle, lCheat, lGodMode;

	int nEgoX, nEgoY = nAppH - 40, nEgoDir, nEgoPic,
	 nEgoLives, nEgoScore, nNextLife, nEgoCount, nEgoDelay = 100,
	 nEgoHP, nEgoShieldCount, nEgoBombs;
	boolean lEgoAlive = true;

	int nWeaponDelay = 25, nWeaponCount, nWeaponLevel,
	 nWeaponType, nWeaponLaserSize, nWeaponTarget = -1;
	boolean lWeaponLaserOn;

	int nShips = 20, nShipNew, nShipWait = 0, nShipX[], nShipY[], nShipHP[],
	 nShipFrame[], nShipCount[], nShipDelay[], nShipShootCount[],
	 nShipShootDelay[];
	boolean lShip[];

	int nPops = 30, nPopFrame[], nPopX[], nPopY[], nPopCount[], nPopDelay = 3;
	boolean lPop[];

	int nCapsules = 10, nCapsuleChance = 2, nCapsuleX[], nCapsuleY[],
	 nCapsuleType[], nCapsuleFrame[], nCapsuleCount[], nCapsuleDelay = 10;
	boolean lCapsule[];

	int nBonuses = 10, nBonusX[], nBonusY[], nBonusType[], nBonusFrame[], 
	 nBonusCount[], nBonusDelay = 2;
	boolean lBonus[];

	int nStars = 10, nStarNew = 50, nStarWait = 0;
	int nStarX[], nStarY[], nStarYD[], nStarPic[];
	boolean lStar[];

	int nMaxBullets = 100, nBulletX[], nBulletY[], nBulletW[], nBulletH[],
	 nBulletXD[], nBulletYD[], nBulletType[], nBulletDamage[], nBulletTarget[];
	boolean lBullet[];

	int nEBullets = 100, nEBulletX[], nEBulletY[], nEBulletXD[],
	 nEBulletYD[], nEBulletType[], nEBulletDamage[];
	boolean lEBullet[];

	int nBombs = 2, nBombFrame[], nBombX[], nBombY[], nBombCount[], nBombDelay = 3;
	boolean lBomb[];

	int nWave, nWaveCount, nWaveDelay = 300, nWaveShips, nWaveMade, nWaveShipHP;
	boolean lWaveOn;

	public void init()
	{
		aChars    = new char[20];
		nBulletX  = new int[nMaxBullets];
		nBulletY  = new int[nMaxBullets];
		nBulletW  = new int[nMaxBullets];
		nBulletH  = new int[nMaxBullets];
		nBulletXD = new int[nMaxBullets];
		nBulletYD = new int[nMaxBullets];
		nBulletType = new int[nMaxBullets];
		nBulletDamage = new int[nMaxBullets];
		nBulletTarget = new int[nMaxBullets];
		lBullet   = new boolean[nMaxBullets];
		nEBulletX  = new int[nEBullets];
		nEBulletY  = new int[nEBullets];
		nEBulletXD = new int[nEBullets];
		nEBulletYD = new int[nEBullets];
		nEBulletType = new int[nEBullets];
		nEBulletDamage = new int[nEBullets];
		lEBullet   = new boolean[nEBullets];
		nShipX    = new int[nShips];
		nShipY    = new int[nShips];
		nShipHP   = new int[nShips];
		nShipFrame = new int[nShips];
		nShipCount = new int[nShips];
		nShipDelay = new int[nShips];
		nShipShootCount = new int[nShips];
		nShipShootDelay = new int[nShips];
		lShip     = new boolean[nShips];
		nPopX     = new int[nPops];
		nPopY     = new int[nPops];
		nPopFrame = new int[nPops];
		nPopCount = new int[nPops];
		lPop      = new boolean[nPops];
		nBombX     = new int[nBombs];
		nBombY     = new int[nBombs];
		nBombFrame = new int[nBombs];
		nBombCount = new int[nBombs];
		lBomb      = new boolean[nBombs];
		nBonusX   = new int[nBonuses];
		nBonusY   = new int[nBonuses];
		nBonusType = new int[nBonuses];
		nBonusCount = new int[nBonuses];
		nBonusFrame = new int[nBonuses];
		lBonus    = new boolean[nBonuses];
		nCapsuleX = new int[nCapsules];
		nCapsuleY = new int[nCapsules];
		nCapsuleType = new int[nCapsules];
		nCapsuleCount = new int[nCapsules];
		nCapsuleFrame = new int[nCapsules];
		lCapsule  = new boolean[nCapsules];
		nStarX    = new int[nStars];
		nStarY    = new int[nStars];
		nStarYD   = new int[nStars];
		nStarPic  = new int[nStars];
		lStar     = new boolean[nStars];
		gEgo      = new Image[3];
		gStar     = new Image[10];
		gShip     = new Image[10];
		gNumber   = new Image[10];
		gCapsule  = new Image[2];
		gBonus    = new Image[14];
		gExplode  = new Image[6];
		gBullet   = new Image[12];
		gEBullet  = new Image[1];
		gShield   = new Image[8];

		// Setup buffer space and graphic objects.
		gBuffer = createImage(nAppH, nAppW);
		oGraphics = gBuffer.getGraphics();
		oTracker = new MediaTracker(this);
		
		// Load ego's ship
		gEgos = getImage(getCodeBase(),"Ego.gif");
		oTracker.addImage(gEgos, 0);
		for(i=0;i<3;i++)
		{
			// Load each ego frame
			oFilter = new CropImageFilter(i * 40, 0, 40, 40);
			gEgo[i] = createImage(new FilteredImageSource(gEgos.getSource(), oFilter));
		}

		// Load enemy ships
		gShips = getImage(getCodeBase(),"Ships.gif");
		oTracker.addImage(gShips, 1);
		for(i=0;i<6;i++)
		{
			// Load each ship
			oFilter = new CropImageFilter(i * 32, 0, 32, 32);
			gShip[i] = createImage(new FilteredImageSource(gShips.getSource(), oFilter));
		}

		// Load all stars
		gStars = getImage(getCodeBase(),"Stars.gif");
		oTracker.addImage(gStars, 2);
		for(i=0;i<10;i++)
		{
			// Load each star
			oFilter = new CropImageFilter(i * 24, 0, 24, 24);
			gStar[i] = createImage(new FilteredImageSource(gStars.getSource(), oFilter));
		}

		// Load numbers
		gNumbers = getImage(getCodeBase(),"Numbers.gif");
		oTracker.addImage(gNumbers, 3);
		for(i=0;i<10;i++)
		{
			// Load each number
			oFilter = new CropImageFilter(i * 10, 0, 10, 20);
			gNumber[i] = createImage(new FilteredImageSource(gNumbers.getSource(), oFilter));
		}

		// Load explosions
		gExplodes = getImage(getCodeBase(),"Explode.gif");
		oTracker.addImage(gExplodes, 4);
		for(i=0;i<6;i++)
		{
			// Load each explosion
			oFilter = new CropImageFilter(i * 32, 0, 32, 32);
			gExplode[i] = createImage(new FilteredImageSource(gExplodes.getSource(), oFilter));
		}

		// Load capsules
		gCapsules = getImage(getCodeBase(),"Capsules.gif");
		oTracker.addImage(gCapsules, 5);
		for(i=0;i<2;i++)
		{
			// Load each capsule
			oFilter = new CropImageFilter(i * 32, 0, 32, 32);
			gCapsule[i] = createImage(new FilteredImageSource(gCapsules.getSource(), oFilter));
		}

		// Load bonuses
		gBonuses = getImage(getCodeBase(),"Bonus.gif");
		oTracker.addImage(gBonuses, 6);
		for(i=0;i<14;i++)
		{
			// Load each bonus
			oFilter = new CropImageFilter(i * 16, 0, 16, 16);
			gBonus[i] = createImage(new FilteredImageSource(gBonuses.getSource(), oFilter));
		}

		// Load bullets
		gBullets = getImage(getCodeBase(),"Bullets.gif");
		oTracker.addImage(gBullets, 7);
		for(i=0;i<3;i++)
		{
			// Load each bullet
			oFilter = new CropImageFilter(i * 8, 0, 8, 16);
			gBullet[i] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		}

		// Load each laser
		oFilter = new CropImageFilter(24, 0, 4, 16);
		gBullet[3] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		oFilter = new CropImageFilter(24 + 4, 0, 8, 16);
		gBullet[4] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		oFilter = new CropImageFilter(24 + 12, 0, 16, 16);
		gBullet[5] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		oFilter = new CropImageFilter(24 + 28, 0, 32, 16);
		gBullet[6] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		// Load other bullets
		for(i=0;i<5;i++)
		{
			oFilter = new CropImageFilter(84 + (i * 16), 0, 16, 16);
			gBullet[7 + i] = createImage(new FilteredImageSource(gBullets.getSource(), oFilter));
		}

		// Load enemy bullets
		gEBullets = getImage(getCodeBase(),"EnemyBullets.gif");
		oTracker.addImage(gEBullets, 8);
		for(i=0;i<1;i++)
		{
			// Load each bullet
			oFilter = new CropImageFilter(i * 8, 0, 8, 8);
			gEBullet[i] = createImage(new FilteredImageSource(gEBullets.getSource(), oFilter));
		}

		// Load shield meter
		gShields = getImage(getCodeBase(),"Shields.gif");
		oTracker.addImage(gShields, 9);
		for(i=0;i<8;i++)
		{
			// Load each bullet
			oFilter = new CropImageFilter(i * 7, 0, 7, 20);
			gShield[i] = createImage(new FilteredImageSource(gShields.getSource(), oFilter));
		}

		// Load status bar info.
		gStatusBar = getImage(getCodeBase(),"StatusBar.gif");
		oTracker.addImage(gStatusBar, 10);

		// Load ego shield.
		gEgoShield = getImage(getCodeBase(),"EgoShield.gif");
		oTracker.addImage(gEgoShield, 11);

		// Load title screen.
		gTitle = getImage(getCodeBase(),"Title.gif");
		oTracker.addImage(gTitle, 12);

		// Wait for all the images to be loaded.
		for(i=0; i<13; i++)
		{
			try
			{
				oTracker.waitForID(i);
			}
				catch(InterruptedException e) {}
		}

		// Setup colors.
		nBlack   = new Color(0, 0, 0);
		nWhite   = new Color(255, 255, 255);
		nMagenta = new Color(255, 0, 255);

		GameOver();

		resize(nAppW, nAppH);
	}

	public void run()
	{
		while (updateThread !=null)
		{
			// 5 millisecond delay.
			try
			{
				updateThread.sleep(5);
			} catch (InterruptedException e) {}

			if(lTitle == true)
			{
				nTitleY--;
				if(nTitleY < 0)
				{
					nTitleY = 0;
				}
			}
			else
			{
				if(lWaveOn == true)
				{
					nWaveCount ++;
					if(nWaveCount == nWaveDelay)
					{
						nWaveCount = 0;
						lWaveOn = false;
					}
				}

				DoEgo();
				DoStars();
				DoBullets();
				DoBombs();
				DoShips();
				DoEBullets();
				DoCapsules();
				DoBonuses();
				CheckCollide();
				DoExplosions();
			}

			DoStars();

			// Refresh the screen.
			repaint();
		}
	}

	public void DoEgo()
	{
		if(lEgoAlive == true)
		{
			nEgoPic = 0;

			// Move Ego
			if(lLeft == true)
			{
				nEgoX -= 5;
				nEgoPic = 1;
			}
			if(lRight == true)
			{
				nEgoX += 5;
				nEgoPic = 2;
			}

			// Stop at walls.
			if(nEgoX < 0)
			{
				nEgoX = 0;
			}
			if(nEgoX > nAppW - 40)
			{
				nEgoX = nAppW - 40;
			}
		}
		else
		{
			nEgoCount++;
			if(nEgoCount < 30 && nEgoCount % 5 == 0)
			{
				MakePop((int) ((nEgoX - 10) + oMath.floor(oMath.random() * 28)), (int) ((nEgoY - 10) + oMath.floor(oMath.random() * 28)));
			}

			if(nEgoCount >= nEgoDelay)
			{
				j = 0;
				for(i=0;i<nShips;i++)
				{
					if(lShip[i] == true)
					{
						j = 1;
						break;
					}
				}
				if(j == 0)
				{
					nEgoCount = 0;
					SetupEgo();
				}
			}
		}
	}

	public void DoStars()
	{
		for(i=0;i<nStars;i++)
		{
			if(lStar[i] == false)
			{
				nStarWait++;
				if(nStarWait == nStarNew)
				{
					nStarWait   = 0;
					lStar[i]    = true;
					nStarX[i]   = (int) oMath.floor(oMath.random() * (nAppW - 32));
					nStarY[i]   = 0;
					nStarYD[i]  = (int) oMath.floor(oMath.random() * (10)) + 1;
					nStarPic[i] = (int) oMath.floor(oMath.random() * 10);
				}
			}
			else
			{
				if(nStarY[i] > nAppH)
				{
					lStar[i] = false;
				}
				else
				{
					nStarY[i] = nStarY[i] + nStarYD[i];
				}
			}
		}
	}

	public void DoShips()
	{
		// No ship functions during wave intervals.
		if(lWaveOn == true)
		{
			return;
		}

		nShipWait++;
		if(nShipWait == nShipNew)
		{
			nShipWait = 0;

			// Check for the end of a wave.
			if(nWaveMade == nWaveShips)
			{
				j = 0;
				for(i=0;i<nShips;i++)
				{
					if(lShip[i] == true)
					{
						j = 1;
						break;
					}
				}
				if(j == 0)
				{
					NextWave();
				}
			}
			else
			{
				if(lEgoAlive == true)
				{
					// Generate more ships.
					for(i=0;i<nShips;i++)
					{
						if(lShip[i] == false)
						{
							nWaveMade++;
							lShip[i] = true;
							nShipX[i] = (int) oMath.floor(oMath.random() * (nAppW - 32));
							nShipY[i] = -16;
							nShipHP[i] = nWaveShipHP;
							nShipFrame[i] = 0;
							nShipCount[i] = 0;
							nShipDelay[i] = 20;
							nShipShootDelay[i] = 100;
							nShipShootCount[i] = (int) oMath.floor(oMath.random() * nShipShootDelay[i]);
							break;
						}
					}
				}
			}
		}

		for(i=0;i<nShips;i++)
		{
			if(lShip[i] == true)
			{
				// Animate Ships.
				nShipCount[i]++;
				if(nShipCount[i] >= nShipDelay[i])
				{
					nShipCount[i] = 0;
					nShipFrame[i]++;
					if(nShipFrame[i] > 2)
					{
						nShipFrame[i] = 0;
					}
				}

				// Ships Shoot.
				nShipShootCount[i]++;
				if(nShipShootCount[i] >= nShipShootDelay[i])
				{
					nShipShootCount[i] = 0;
					MakeEBullet(nShipX[i] + 12, nShipY[i] + 12, (int) oMath.floor(oMath.random() * 3) - 1, 3);
				}

				// Move ships.
				if(nShipY[i] > nAppH)
				{
					lShip[i] = false;
				}
				else
				{
					nShipY[i] = nShipY[i] + 2;
				}
			}
		}
	}

	public void DoEBullets()
	{
		// Move enemy bullets.
		for(i=0;i<nEBullets;i++)
		{
			if(lEBullet[i] == true)
			{
				nEBulletX[i] += nEBulletXD[i];
				nEBulletY[i] += nEBulletYD[i];
				if(nEBulletX[i] < 0 || nEBulletX[i] > nAppW ||
				 nEBulletY[i] < 0 || nEBulletY[i] > nAppH)
				{
					lEBullet[i] = false;
				}
			}
		}
	}

	public void DoBullets()
	{
		// Check for shooting
		lWeaponLaserOn = false;
		if(lShoot == true)
		{
			nWeaponCount++;
			if(nWeaponCount >= nWeaponDelay)
			{
				nWeaponCount = 0;
				switch(nWeaponType)
				{
				case 0:		// Rapid Fire
					switch(nWeaponLevel)
					{
					case 0:
						MakeBullet(nEgoX + 7, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 23, nEgoY + 16, 0, -5, 0);
						break;
					case 1:
						MakeBullet(nEgoX + 7, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 15, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 23, nEgoY + 16, 0, -5, 0);
						break;
					case 2:
						MakeBullet(nEgoX + 3, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 11, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 19, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 27, nEgoY + 16, 0, -5, 0);
						break;
					case 3:
						MakeBullet(nEgoX + 3, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 11, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 19, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 27, nEgoY + 16, 0, -5, 0);
						MakeBullet(nEgoX + 15, nEgoY + 16, 0, -5, 0);
						break;
					}
					break;
				case 1:		// Laser
					lWeaponLaserOn = true;
					break;
				case 2:		// Power
					MakeBullet(nEgoX + 15, nEgoY + 16, 0, (-7 - nWeaponLevel), 2);
					break;
				case 3:		// Spread
					for(i=(-1 * (nWeaponLevel + 1));i<(nWeaponLevel + 2);i++)
					{
						MakeBullet(nEgoX + 15, nEgoY + 16, i, -5, 3);
					}
					break;
				case 4:		// Homing
					break;
				case 5:		// Omni
					MakeBullet(nEgoX + 15, nEgoY + 16, 1, -1, 5);
					break;
				case 6:		// Auto Laser
					lWeaponLaserOn = true;
					// See if target is still there.
					if(nWeaponTarget > -1)
					{
						if(lShip[nWeaponTarget] == false)
						{
							nWeaponTarget = -1;
						}
					}
					if(nWeaponTarget == -1)
					{
						// No target, get a new one.
						for(i=0;i<nShips;i++)
						{
							if(lShip[i] == true)
							{
								nWeaponTarget = i;
								break;
							}
						}
						if(nWeaponTarget == -1);
						{
							lWeaponLaserOn = false;
						}
					}
					break;
				}
			}
		}
		else
		{
			nWeaponCount = 0;
		}

		// Check for bullet
		for(i=0;i<nMaxBullets;i++)
		{
			if(lBullet[i] == true)
			{
				nBulletX[i] += nBulletXD[i];
				nBulletY[i] += nBulletYD[i];

				// Check if bullet left the screen.
				if(nBulletY[i] < -50 || nBulletY[i] > nAppH + 50 || 
				 nBulletX[i] < -50 || nBulletX[i] > nAppW + 50)
				{
					lBullet[i] = false;
				}
			}
		}
	}

	public void DoBombs()
	{
		if(lBomb[0] == true)
		{
			// Animate Bomb
			nBombCount[0]++;
			if(nBombCount[0] > nBombDelay)
			{
				nBombCount[0] = 0;
				nBombFrame[0]++;
				if(nBombFrame[0] == 2)
				{
					nBombFrame[0] = 0;
				}
			}

			// Move Bomb
			nBombY[0]--;
			if(nBombY[0] < (int) (nAppH / 2))
			{
				// Pop Bomb
				lBomb[0] = false;
				for(i=-3;i<4;i++)
				{
					for(j=-3;j<4;j++)
					{
						if(!(i == 0 && j == 0))
						{
							MakeBullet(nBombX[0], nBombY[0], i, j, 9);
						}
					}
				}
			}
		}
		else
		{
			if(lBombing == true)
			{
				if(nEgoBombs > 0)
				{
					// Player shot a bomb.
					nEgoBombs--;
					lBomb[0] = true;
					nBombX[0] = nEgoX + 12;
					nBombY[0] = nEgoY + 10;
					nBombCount[0] = 0;
					nBombFrame[0] = 0;
				}
			}
		}
	}

	public void DoCapsules()
	{
		// Randomly create capsules.
		if(lCapsule[0] == false && lBonus[0] == false && lWaveOn == false)
		{
			if(oMath.floor(oMath.random() * 1000) < nCapsuleChance)
			{
				lCapsule[0]      = true;
				nCapsuleX[0]     = (int) oMath.floor(oMath.random() * (nAppW - 32));
				nCapsuleY[0]     = -16;
				nCapsuleFrame[0] = 0;
				nCapsuleType[0]  = (int) oMath.floor(oMath.random() * 2);
				if(nCapsuleType[0] == 0)
				{
					// Weapons
					nCapsuleType[0] = (int) oMath.floor(oMath.random() * 4);
				}
				else
				{
					// Bonuses
					nCapsuleType[0] = (int) oMath.floor(oMath.random() * 14);
					switch(nCapsuleType[0])
					{
					case 0: case 1: case 2: case 3: case 4:
						nCapsuleType[0] = 10;
						break;
					case 5: case 6: case 7:
						nCapsuleType[0] = 11;
						break;
					case 8: case 9:
						nCapsuleType[0] = 12;
						break;
					case 10: case 11: case 12: case 13:
						nCapsuleType[0] = 13;
						break;
					}
				}
			}
		}

		for(i=0;i<nCapsules;i++)
		{
			if(lCapsule[i] == true)
			{
				// Animate Capsule.
				nCapsuleCount[i]++;
				if(nCapsuleCount[i] >= nCapsuleDelay)
				{
					nCapsuleCount[i] = 0;
					nCapsuleFrame[i]++;
					if(nCapsuleFrame[i] > 1)
					{
						nCapsuleFrame[i] = 0;
					}
				}

				// Move Capsule.
				if(nCapsuleY[i] > nAppH)
				{
					lCapsule[i] = false;
				}
				else
				{
					nCapsuleY[i] = nCapsuleY[i] + 2;
				}
			}
		}
	}

	// Move bonuses.
	public void DoBonuses()
	{
		for(i=0;i<nBonuses;i++)
		{
			if(lBonus[i] == true)
			{
				if(nBonusY[i] > nAppH)
				{
					lBonus[i] = false;
				}
				else
				{
					nBonusY[i] = nBonusY[i] + 1;
					//nBonusX[i] = nBonusX[i] + nBonusDir[i];
					if(nBonusX[i] < 0)
					{
						nBonusX[i] = 0;
						//nBonusDir[i] = -nBonusDir[i];
					}
					if(nBonusX[i] > nAppW - 16)
					{
						nBonusX[i] = nAppW - 16;
						//nBonusDir[i] = -nBonusDir[i];
					}
				}
			}
		}
	}

	public void DoExplosions()
	{
		for(i=0;i<nPops;i++)
		{
			if(lPop[i] == true)
			{
				nPopCount[i]++;
				if(nPopCount[i] >= nPopDelay)
				{
					nPopCount[i] = 0;
					nPopFrame[i]++;
				}

				if(nPopFrame[i] == 6)
				{
					lPop[i] = false;
				}
			}
		}
	}

	public void CheckCollide()
	{
		// Special shooting for auto laser.
		if(nWeaponType == 6 && lWeaponLaserOn == true && lShip[nWeaponTarget] == true)
		{
			HitEnemy(nWeaponTarget, 1);
		}

		// Check for bullet hitting ships
		for(i=0;i<nShips;i++)
		{
			if(lShip[i] == true)
			{
				if(nWeaponType == 1 && lWeaponLaserOn == true)
				{
					// Check if ship is inside laser beam.
					if((nShipX[i] >= (nEgoX + 20) - nWeaponLaserSize && nShipX[i] <= (nEgoX + 20) + nWeaponLaserSize)
					 || (nShipX[i] + 32 >= (nEgoX + 20) - nWeaponLaserSize && nShipX[i] + 32<= (nEgoX + 20) + nWeaponLaserSize)
					 || (nShipX[i] <= (nEgoX + 20) - nWeaponLaserSize && nShipX[i] + 32 >= (nEgoX + 20) + nWeaponLaserSize))
					{
						HitEnemy(i, 1);
					}
				}

				for(j=0;j<nMaxBullets;j++)
				{
					if(lBullet[j] == true && lShip[i] == true)
					{
						if((nBulletX[j] >= nShipX[i] && nBulletX[j] <= nShipX[i] + 32
						 && nBulletY[j] >= nShipY[i] && nBulletY[j] <= nShipY[i] + 32) ||
						 (nBulletX[j] + nBulletW[j] >= nShipX[i] && nBulletX[j] + nBulletW[j] <= nShipX[i] + 32 
						 &&	nBulletY[j] >= nShipY[i] && nBulletY[j] <= nShipY[i] + 32) ||
						 (nBulletX[j] >= nShipX[i] && nBulletX[j] <= nShipX[i] + 32 
						 && nBulletY[j] + nBulletH[j] >= nShipY[i] && nBulletY[j] + nBulletH[j] <= nShipY[i] + 32) ||
						 (nBulletX[j] + nBulletW[j] >= nShipX[i] && nBulletX[j] + nBulletW[j] <= nShipX[i] + 32 
						 && nBulletY[j] + nBulletH[j] >= nShipY[i] && nBulletY[j] + nBulletH[j] <= nShipY[i] + 32))
						{
							lBullet[j] = false;
							HitEnemy(i, nBulletDamage[j]);
						}
					}
				}
			}
		}

		// Check for bullet hitting capsules
		for(i=0;i<nCapsules;i++)
		{
			if(lCapsule[i] == true)
			{
				if(nWeaponType == 1 && lShoot == true)
				{
					// Check if capsule is inside laser beam.
					if((nCapsuleX[i] >= (nEgoX + 20) - nWeaponLaserSize && nCapsuleX[i] <= (nEgoX + 20) + nWeaponLaserSize)
					 || (nCapsuleX[i] + 32 >= (nEgoX + 20) - nWeaponLaserSize && nCapsuleX[i] + 32 <= (nEgoX + 20) + nWeaponLaserSize)
					 || (nCapsuleX[i] <= (nEgoX + 20) - nWeaponLaserSize && nCapsuleX[i] + 32 >= (nEgoX + 20) + nWeaponLaserSize))
					{
						PopCapsule(i);
					}
				}
				else
				{
					for(j=0;j<nMaxBullets;j++)
					{
						if(lBullet[j] == true)
						{
							if((nBulletX[j] >= nCapsuleX[i] && nBulletX[j] <= nCapsuleX[i] + 32
							 && nBulletY[j] >= nCapsuleY[i] && nBulletY[j] <= nCapsuleY[i] + 32) ||
							 (nBulletX[j] + nBulletW[j] >= nCapsuleX[i] && nBulletX[j] + nBulletW[j] <= nCapsuleX[i] + 32
							 &&	nBulletY[j] >= nCapsuleY[i] && nBulletY[j] <= nCapsuleY[i] + 32) ||
							 (nBulletX[j] >= nCapsuleX[i] && nBulletX[j] <= nCapsuleX[i] + 32 
							 && nBulletY[j] + nBulletH[j] >= nCapsuleY[i] && nBulletY[j] + nBulletH[j] <= nCapsuleY[i] + 32) ||
							 (nBulletX[j] + nBulletW[j] >= nCapsuleX[i] && nBulletX[j] + nBulletW[j] <= nCapsuleX[i] + 32 
							 && nBulletY[j] + nBulletH[j] >= nCapsuleY[i] && nBulletY[j] + nBulletH[j] <= nCapsuleY[i] + 32))
							{
								lBullet[j] = false;
								PopCapsule(i);
								break;
							}
						}
					}
				}
			}
		}

		// Check for bullet hitting bonuses
		for(i=0;i<nBonuses;i++)
		{
			if(lBonus[i] == true && nBonusType[i] < 10)
			{
				if(nWeaponType == 1 && lShoot == true)
				{
					// Check if bonus is inside laser beam.
					if((nBonusX[i] >= (nEgoX + 20) - nWeaponLaserSize && nBonusX[i] <= (nEgoX + 20) + nWeaponLaserSize)
					 || (nBonusX[i] + 16 >= (nEgoX + 20) - nWeaponLaserSize && nBonusX[i] + 16 <= (nEgoX + 20) + nWeaponLaserSize)
					 || (nBonusX[i] <= (nEgoX + 20) - nWeaponLaserSize && nBonusX[i] + 16 >= (nEgoX + 20) + nWeaponLaserSize))
					{
						BumpBonus(i);
					}
				}
				else
				{
					for(j=0;j<nMaxBullets;j++)
					{
						if(lBullet[j] == true)
						{
							if((nBulletX[j] >= nBonusX[i] && nBulletX[j] <= nBonusX[i] + 16
							 && nBulletY[j] >= nBonusY[i] && nBulletY[j] <= nBonusY[i] + 16) ||
							 (nBulletX[j] + nBulletW[j] >= nBonusX[i] && nBulletX[j] + nBulletW[j] <= nBonusX[i] + 16
							 &&	nBulletY[j] >= nBonusY[i] && nBulletY[j] <= nBonusY[i] + 16) ||
							 (nBulletX[j] >= nBonusX[i] && nBulletX[j] <= nBonusX[i] + 16 
							 && nBulletY[j] + nBulletH[j] >= nBonusY[i] && nBulletY[j] + nBulletH[j] <= nBonusY[i] + 16) ||
							 (nBulletX[j] + nBulletW[j] >= nBonusX[i] && nBulletX[j] + nBulletW[j] <= nBonusX[i] + 16 
							 && nBulletY[j] + nBulletH[j] >= nBonusY[i] && nBulletY[j] + nBulletH[j] <= nBonusY[i] + 16))
							{
								lBullet[j] = false;
								BumpBonus(i);
								break;
							}
						}
					}
				}
			}
		}

		if(lEgoAlive == true)
		{
			// Check for ego hitting ship
			for(i=0;i<nShips;i++)
			{
				if(lShip[i] == true)
				{
					if((nShipX[i] >= nEgoX && nShipX[i] <= nEgoX + 40
					 && nShipY[i] >= nEgoY && nShipY[i] <= nEgoY + 40) ||
					 (nShipX[i] + 32 >= nEgoX && nShipX[i] + 32 <= nEgoX + 40
					 &&	nShipY[i] >= nEgoY && nShipY[i] <= nEgoY + 40) ||
					 (nShipX[i] >= nEgoX && nShipX[i] <= nEgoX + 40
					 && nShipY[i] + 32 >= nEgoY && nShipY[i] + 32 <= nEgoY + 40) ||
					 (nShipX[i] + 32 >= nEgoX && nShipX[i] + 32 <= nEgoX + 40 
					 && nShipY[i] + 32 >= nEgoY && nShipY[i] + 32 <= nEgoY + 40))
					{
						j = nEgoHP;
						HitEgo(nShipHP[i]);
						HitEnemy(i, j);
						break;
					}
				}
			}

			// Check for ego hitting enemy bullet
			for(i=0;i<nEBullets;i++)
			{
				if(lEBullet[i] == true)
				{
					if((nEBulletX[i] >= nEgoX && nEBulletX[i] <= nEgoX + 40
					 && nEBulletY[i] >= nEgoY && nEBulletY[i] <= nEgoY + 40) ||
					 (nEBulletX[i] + 8 >= nEgoX && nEBulletX[i] + 8 <= nEgoX + 40
					 &&	nEBulletY[i] >= nEgoY && nEBulletY[i] <= nEgoY + 40) ||
					 (nEBulletX[i] >= nEgoX && nEBulletX[i] <= nEgoX + 40
					 && nEBulletY[i] + 8 >= nEgoY && nEBulletY[i] + 8 <= nEgoY + 40) ||
					 (nEBulletX[i] + 8 >= nEgoX && nEBulletX[i] + 8 <= nEgoX + 40 
					 && nEBulletY[i] + 8 >= nEgoY && nEBulletY[i] + 8 <= nEgoY + 40))
					{
						lEBullet[i] = false;
						HitEgo(1);
						break;
					}
				}
			}

			// Check for ego hitting bonus
			for(j=0;j<nBonuses;j++)
			{
				if(lBonus[j] == true)
				{
					if((nBonusX[j] >= nEgoX && nBonusX[j] <= nEgoX + 40
					 && nBonusY[j] >= nEgoY && nBonusY[j] <= nEgoY + 40) ||
					 (nBonusX[j] + 16 >= nEgoX && nBonusX[j] + 16 <= nEgoX + 40
					 &&	nBonusY[j] >= nEgoY && nBonusY[j] <= nEgoY + 40) ||
					 (nBonusX[j] >= nEgoX && nBonusX[j] <= nEgoX + 40
					 && nBonusY[j] + 16 >= nEgoY && nBonusY[j] + 16 <= nEgoY + 40) ||
					 (nBonusX[j] + 16 >= nEgoX && nBonusX[j] + 16 <= nEgoX + 40 
					 && nBonusY[j] + 16 >= nEgoY && nBonusY[j] + 16 <= nEgoY + 40))
					{
						lBonus[j] = false;
						GiveBonus(nBonusType[j]);
					}
				}
			}
		}
	}

	public void HitEgo(int nDamage)
	{
		if(lGodMode == false)
		{
			nEgoHP -= nDamage;
			if(nEgoHP <= 0)
			{
				lShoot = false;
				lEgoAlive = false;
			}
			else
			{
				nEgoShieldCount = 10;
			}

		}
	}

	public void BumpBonus(int nBonus)
	{
		nBonusY[nBonus] -= 30;
		if(nBonusY[nBonus] < 24)
		{
			nBonusY[nBonus] = 24;
		}
		
		nBonusType[nBonus]++;
		if(nBonusType[nBonus] == 4)
		{
			nBonusType[nBonus] = 0;
		}
	}

	public void MakeBullet(int X, int Y, int XD, int YD, int nType)
	{
		for(k=0;k<nMaxBullets;k++)
		{
			if(lBullet[k] == false)
			{
				lBullet[k] = true;
				nBulletX[k] = X;
				nBulletY[k] = Y;
				nBulletXD[k] = XD;
				nBulletYD[k] = YD;

				switch(nType)
				{
				case 0:			// Rapid
					nBulletType[k] = 0;
					nBulletDamage[k] = 1;
					nBulletW[k] = 8;
					nBulletH[k] = 16;
					break;
				case 2:			// Power
					nBulletType[k] = 1;
					nBulletDamage[k] = (int) oMath.pow(2, (nWeaponLevel + 1));
					nBulletW[k] = 8;
					nBulletH[k] = 16;
					break;
				case 3:			// Spread
					nBulletType[k] = 2;
					nBulletDamage[k] = 1;
					nBulletW[k] = 8;
					nBulletH[k] = 16;
					break;
				case 4:		// Homing
					break;
				case 5:		// Omni
					nBulletType[k] = 8;
					nBulletDamage[k] = 1;
					nBulletW[k] = 16;
					nBulletH[k] = 16;
					break;
				case 6:		// Auto Laser
					break;
				case 9:		// Bomb
					nBulletType[k] = 9;
					nBulletDamage[k] = 16;
					nBulletW[k] = 16;
					nBulletH[k] = 16;
				}
				break;
			}
		}
	}

	public void MakeEBullet(int X, int Y, int XD, int YD)
	{
		for(k=0;k<nEBullets;k++)
		{
			if(lEBullet[k] == false)
			{
				lEBullet[k]   = true;
				nEBulletX[k]  = X;
				nEBulletY[k]  = Y;
				nEBulletXD[k] = XD;
				nEBulletYD[k] = YD;
				break;
			}
		}
	}

	public void PopCapsule(int nCapsule)
	{
		lCapsule[nCapsule] = false;
		GiveScore(5);
		// Make a bonus object.
		for(k=0;k<nBonuses;k++)
		{
			if(lBonus[k] == false)
			{
				lBonus[k]      = true;
				nBonusX[k]     = nCapsuleX[nCapsule] + 12;
				nBonusY[k]     = nCapsuleY[nCapsule] + 12;
				nBonusType[k]  = nCapsuleType[nCapsule];
				nBonusFrame[k] = 0;
				MakePop(nCapsuleX[nCapsule], nCapsuleY[nCapsule]);
				break;
			}
		}
	}

	// Hurt the enemy.
	public void HitEnemy(int nEnemy, int nDamage)
	{
		nShipHP[nEnemy] -= nDamage;
		if(nShipHP[nEnemy] <= 0)
		{
			lShip[nEnemy] = false;
			MakePop(nShipX[nEnemy], nShipY[nEnemy]);
			GiveScore(25 * nWave);
		}
		else
		{
			MakePop(nShipX[nEnemy], nShipY[nEnemy]);
		}
	}

	public void MakePop(int X, int Y)
	{
		for(k=0;k<nPops;k++)
		{
			if(lPop[k] == false)
			{
				lPop[k] = true;
				nPopX[k] = X;
				nPopY[k] = Y;
				nPopFrame[k] = 0;
				break;
			}
		}
	}

	public void SetupEgo()
	{
		lEgoAlive = true;

		// Reset gun
		nWeaponType   = 0;
		nWeaponDelay  = 25;
		nWeaponLevel  = 0;

		// If the player has no bombs, give them one.
		nEgoBombs = 1;

		// Remove life.
		nEgoLives--;
		nEgoX = (nAppW / 2) - 20;
		nEgoHP = 5;
		if(nEgoLives < 0)
		{
			GameOver();
		}
	}

	public void GiveScore(int nScore)
	{
		nEgoScore += nScore;
		if(nEgoScore > nNextLife)
		{
			nEgoLives++;
			nNextLife += 10000;
		}
	}

	public void GiveBonus(int nBonus)
	{
		GiveScore(100);

		// Handle all weapon bonuses
		if(nBonus < 10)
		{
			if(nWeaponType == nBonus)
			{
				nWeaponLevel++;
				if(nWeaponLevel > 3)
				{
					nWeaponLevel = 3;
				}
			}
			else
			{
				nWeaponType  = nBonus;
				nWeaponLevel = 0;
			}

			switch(nBonus)
			{
			case 0:					// Rapid Fire
				nWeaponDelay  = 25 - (nWeaponLevel * 5);
				break;
			case 1:					// Laser
				nWeaponDelay  = 9 - (nWeaponLevel * 2);
				nWeaponLaserSize = (int) oMath.pow(2, (nWeaponLevel + 1));
				break;
			case 2:					// Power Gun
				nWeaponDelay  = 22 - (nWeaponLevel * 6);
				break;
			case 3:					// Spread
				nWeaponDelay  = 20;
				break;
			case 4:					// Homing
				break;
			case 5:					// Omni
				nWeaponDelay  = 5;
				break;
			case 6:					// Auto Laser
				nWeaponDelay  = 15 - (nWeaponLevel * 4);
				break;
			}
		}
		else
		{
			switch(nBonus)
			{
			case 10:				// Bonus Points
				nEgoScore += (100 * nWave) - 100;
				break;
			case 11:				// Shield Bonus
				nEgoHP += 5;
				if(nEgoHP > 8)
				{
					nEgoHP = 8;
				}
				break;
			case 12:				// Free Guy
				nEgoLives++;
				break;
			case 13:				// Bomb
				nEgoBombs++;
				break;
			}
		}
	}

	public void GameOver()
	{
		lTitle = true;
		nWave = 0;
		nEgoLives = 3;
		nNextLife = 10000;
		SetupEgo();
		for(i=0;i<nMaxBullets;i++)
		{
			lBullet[i] = false;
		}
		for(i=0;i<nEBullets;i++)
		{
			lEBullet[i] = false;
		}
		for(i=0;i<nBombs;i++)
		{
			lBomb[i] = false;
		}
		for(i=0;i<nBonuses;i++)
		{
			lBonus[i] = false;
		}
		for(i=0;i<nCapsules;i++)
		{
			lCapsule[i] = false;
		}
		for(i=0;i<nPops;i++)
		{
			lPop[i] = false;
		}
		for(i=0;i<nShips;i++)
		{
			lShip[i] = false;
		}
	}

	public boolean keyDown(java.awt.Event e, int nKey)
	{
		// Reset cheat counter.
		if(nKey != 84 && nKey != 65 && nKey != 71)
		{
			nCheatCount = 0;
		}

		switch(nKey)
		{
		case 105: case 73:		// i, I
			lLeft = true;
			break;
		case 112: case 80:		// p, P
			lRight = true;
			break;
		case 32:				// space
			if(lTitle == true)
			{
				lTitle = false;
				nEgoScore = 0;
				NextWave();
			}

			if(lEgoAlive == true)
			{
				if(lShoot == false)
				{
					nWeaponCount = nWeaponDelay - 1;
				}
				lShoot = true;
			}
			break;
		case 98: case 66:		// b, B
			if(lEgoAlive == true)
			{
				lBombing = true;
			}
			break;
		case 84:				// T
			if(nCheatCount == 0)
			{
				nCheatCount++;
			}
			break;
		case 65:				// A
			if(nCheatCount == 1)
			{
				nCheatCount++;
			}
			break;
		case 71:				// G
			if(nCheatCount == 2)
			{
				lCheat = true;
			}
			break;
		case 49:				// 1
			Cheat(0);
			break;
		case 50:				// 2
			Cheat(1);
			break;
		case 51:				// 3
			Cheat(2);
			break;
		case 52:				// 4
			Cheat(3);
			break;
		case 43:				// +
			Cheat(10);
			break;
		case 47:				// /
			Cheat(11);
			break;
		case 42:				// *
			Cheat(12);
			break;
		case 45:				// -
			Cheat(13);
			break;
		case 93:				// ]
			for(i=0;i<nShips;i++)
			{
				lShip[i] = false;
			}
			NextWave();
			break;
		case 126:				// ~
			Cheat(20);
		default:
			break;
		}
		return false;
	}

	public boolean keyUp(java.awt.Event e,int key)
	{
		switch(key)
		{
		case 105: case 73:		// i, I
			lLeft = false;
			break;
		case 112: case 80:		// p, P
			lRight = false;
			break;
		case 32:				// Space
			lShoot = false;
			break;
		case 98: case 66:		// b, B
			lBombing = false;
			break;
		default:
			break;
		}
		return false;
	}

	public void Cheat(int nCheat)
	{
		if(lCheat == true)
		{
			if(nCheat < 20)
			{
				GiveBonus(nCheat);
			}
			else
			{
				switch(nCheat)
				{
				case 20:
					lGodMode = !lGodMode;
				}
			}
		}
	}

	public void DrawNumbers(int nAmount, int X, int Y)
	{
		cNumber = Integer.toString(nAmount);
		cNumber.getChars(0, cNumber.length(), aChars, 0);

		for(i=0;i<cNumber.length();i++)
		{
			oGraphics.drawImage(gNumber[aChars[i] - 48], (X + (i * 10)), Y, this);
		}
	}

	public void NextWave()
	{
		nWave++;
		nWaveCount = 0;
		lWaveOn = true;
		nShipWait = 0;
		nShipNew = 120 - (nWave * 15);
		if(nShipNew < 30)
		{
			nShipNew = 30;
		}
		nWaveShips = 10 + (nWave * 2);
		nShips = 5 + (nWave * 2);
		if(nShips > 20)
		{
			nShips = 20;
		}
		nWaveMade = 0;
		nWaveShipHP = (int) oMath.floor((nWave + 2) / 2);
	}

	public void update(Graphics g)
	{
		// Paint to the buffer.
		oGraphics.setColor(nBlack);
		oGraphics.fillRect(0, 0, nAppW, nAppH);

		// Draw stars
		for(i=0;i<nStars;i++)
		{
			if(lStar[i] == true)
			{
				oGraphics.drawImage(gStar[nStarPic[i]], nStarX[i], nStarY[i], this);
			}
		}

		if(lTitle == true)
		{
			oGraphics.drawImage(gTitle, 0, nTitleY, this);
			DrawNumbers(nEgoScore, 232, 2);
		}
		else
		{
			// Draw Enemy Ships
			for(i=0;i<nShips;i++)
			{
				if(lShip[i] == true)
				{
					oGraphics.drawImage(gShip[nShipFrame[i]], nShipX[i], nShipY[i], this);
				}
			}

			// Draw bullets
			if(nWeaponType == 1 && lShoot == true)		// Laser
			{
				for(i=0;i<(int)(nAppH / 16);i++)
				{
					oGraphics.drawImage(gBullet[nWeaponLevel + 3], (nEgoX + 20) - nWeaponLaserSize, i * 16, this);
				}
			}
			if(nWeaponType == 6 && lWeaponLaserOn == true)
			{
				oGraphics.setColor(nMagenta);
				oGraphics.drawLine(nEgoX + 20, nEgoY + 10, nShipX[nWeaponTarget] + 16, nShipY[nWeaponTarget] + 16);
				oGraphics.drawLine(nEgoX + 20, nEgoY + 10, nShipX[nWeaponTarget] + 15, nShipY[nWeaponTarget] + 16);
				oGraphics.drawLine(nEgoX + 20, nEgoY + 10, nShipX[nWeaponTarget] + 16, nShipY[nWeaponTarget] + 15);
				oGraphics.drawLine(nEgoX + 20, nEgoY + 10, nShipX[nWeaponTarget] + 17, nShipY[nWeaponTarget] + 16);
				oGraphics.drawLine(nEgoX + 20, nEgoY + 10, nShipX[nWeaponTarget] + 16, nShipY[nWeaponTarget] + 17);
			}
			for(i=0;i<nMaxBullets;i++)	// Normal bullets
			{
				if(lBullet[i] == true)
				{
					oGraphics.drawImage(gBullet[nBulletType[i]], nBulletX[i], nBulletY[i], this);
				}
			}

			// Draw Bombs
			for(i=0;i<nBombs;i++)
			{
				if(lBomb[i] == true)
				{
					oGraphics.drawImage(gBullet[10 + nBombFrame[i]], nBombX[i], nBombY[i], this);
				}
			}

			// Draw enemy bullets
			for(i=0;i<nEBullets;i++)
			{
				if(lEBullet[i] == true)
				{
					oGraphics.drawImage(gEBullet[nEBulletType[i]], nEBulletX[i], nEBulletY[i], this);
				}
			}

			// Draw capsules
			for(i=0;i<nCapsules;i++)
			{
				if(lCapsule[i] == true)
				{
					oGraphics.drawImage(gCapsule[nCapsuleFrame[i]], nCapsuleX[i], nCapsuleY[i], this);
				}
			}

			// Draw bonuses
			for(i=0;i<nBonuses;i++)
			{
				if(lBonus[i] == true)
				{
					oGraphics.drawImage(gBonus[nBonusType[i]], nBonusX[i], nBonusY[i], this);
				}
			}

			// Draw Explosions
			for(i=0;i<nPops;i++)
			{
				if(lPop[i] == true)
				{
					oGraphics.drawImage(gExplode[nPopFrame[i]], nPopX[i], nPopY[i], this);
				}
			}

			// Draw Ego
			if(lEgoAlive == true)
			{
				
				oGraphics.drawImage(gEgo[nEgoPic], nEgoX, nEgoY, this);
				if(nEgoShieldCount > 0)
				{
					// Draw the shield if needed.
					nEgoShieldCount--;
					oGraphics.drawImage(gEgoShield, nEgoX - 10, nEgoY - 10, this);
				}
			}

			// Draw Status Bar
			oGraphics.drawImage(gStatusBar, 0, 0, this);

			// Draw Lives
			DrawNumbers(nEgoLives, 35, 2);

			// Draw shield meter
			for(i=0;i<nEgoHP;i++)
			{
				oGraphics.drawImage(gShield[i], 80 + (i * 7), 2, this);
			}

			// Draw Bombs
			DrawNumbers(nEgoBombs, 180, 2);

			// Draw Score
			DrawNumbers(nEgoScore, 232, 2);

			// Draw the Wave number
			if(lWaveOn == true)
			{
				DrawNumbers(nWave, (nAppW / 2) - 10, (nAppH / 2));
			}
		}

		oGraphics.setColor(nWhite);
//		oGraphics.drawString(Integer.toString(nShipWait), 0, 40);

		// Paint the buffer to the screen.
		g.drawImage(gBuffer, 0, 0, this);
	}

	public void start()
	{
		// Create a thread.
		if (updateThread == null)
		{
			updateThread = new Thread(this, "SpaceMission");
			updateThread.start();
		}
	}

	public void stop()
	{
		// Destroy the thread.
		if ((updateThread != null) && (updateThread.isAlive()))
		{
			updateThread.stop();
		}
		updateThread = null;
	}
}
